//---------------------------------------------------------------------------

#ifndef WaveInputH
#define WaveInputH
//---------------------------------------------------------------------------
#include <windows.h>
#include <mmsystem.h>

class WaveIn
{
private:
	HWAVEIN   hWaveIn;
	WAVEHDR*  WaveHeaders;			///< pointer to allocated table of headers
	WAVEFORMATEX  waveFormat;

	int       iBuffIdx;             ///< index of next buffer available for recording
	int       iBuffersCount;        ///< total buffer count for audio data
	int       iSamplesPerChannel;   ///< samples per channels count (in buffer)
	int       WaveBufSize;
	WAVEHDR*  SendHeader;
	bool      bRecordingStarted;    ///< is audio recording started?
	bool	  bDeviceOpened;
	bool	  bStopRequest;

	void __fastcall ProcessSamples();
	bool bSamplesProcessed;
	friend void CALLBACK WaveInProc(HWAVEIN waveOut, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2);

	typedef void (*CallbackLog)(char*);
	typedef void (*CallbackData)(short*, int);
	void log(char *lpData, ...);
public:
	WaveIn();
	~WaveIn();
	int Connect(int iDevId = WAVE_MAPPER);
	int Disconnect(void);
	int RecStart(void);				///< start recording
	int RecStop(void);              ///< stop recording
	CallbackLog callbackLog;
	CallbackData callbackData;
};
extern WaveIn waveIn;

#endif
